<?php

/**
 * Simple Machines Forum (SMF)
 *
 * @package EventEvents
 * @author Zaine
 *
 * @copyright 2011 Innsmouth Enterprises
 * @license http://www.simplemachines.org/about/smf/license.php BSD
 *
 * @version 0.4
 */

if (!defined('SMF'))
	die('Hacking attempt...');

function EveEventAddMenuItem(&$admin_areas) {
	global $txt;

	// add our menu item	
	$admin_areas['config']['areas']['modsettings']['subsections']['eveevents'] = array($txt['eve_events_admin_menu'],);
	return;  
}      
function EveEventAddSettings(&$subActions) {

	// add our admin panel details
	$subActions['eveevents'] = 'EventsModifySettings';
	return;  
}    

function EveEventGetAvailableCharacters($keyid, $vcode) {

	global $sourcedir, $txt, $cachedir;
	
	require_once($sourcedir . '/ale/factory.php');
	
	// Ale will create a cache directory for the api xml.
	// I'm using this rather than the mysql cache due to moding difficulties :/
	define("ALE_CACHE_ROOTDIR", "$cachedir/ale/");
	
	// try hooking to eve and grabbing details
	try {
		$ale = AleFactory::getEVEOnline();
		//set user credentials, third parameter $characterID is also possible;

		$ale->setKey($keyid, $vcode);
		$characterArray = Array();
		$account = $ale->account->Characters();
		foreach ($account->result->characters as $character) {
		
	         $character_id = (string) $character->characterID;
    	     $character_name = (string) $character->name;
    	     
    	     $characterArray[$character_id] = $character_name;
   		}		
	}
	//and finally, we should handle exceptions
	catch (Exception $e) {
		/* Commented out error message to avoid spamming log.  
		 * Instead we are catching a more friendly error message
		 */
		$diemessage = $txt['eve_events_ale_failure'] . $e;
		log_error($diemessage);		
		return;
	}
	return ($characterArray);

}

function EventsModifySettings($return_config = false) {
	global $txt, $scripturl, $context, $modSettings, $sourcedir, $boards, $smcFunc;
    
	require_once($sourcedir . "/Subs-Boards.php");
    	
	// generate board array.	
	$boardoptions_1 = array('select', 'eveevents_boardid_1');	
	$boardoptions_2 = array('select', 'eveevents_boardid_2');
	$boardoptions_3 = array('select', 'eveevents_boardid_3');
	$boardoptions_4 = array('select', 'eveevents_boardid_4');
	$boardoptions_5 = array('select', 'eveevents_boardid_5');
	$boardoptionsdata = array('Please select...');

	// Load the boards list - for the board selection.  Stolen from ManageBoards.php
	$board_names = array('');
	$request = $smcFunc['db_query']('order_by_board_order', '
		SELECT b.id_board, b.name AS board_name, c.name AS cat_name
		FROM {db_prefix}boards AS b
			LEFT JOIN {db_prefix}categories AS c ON (c.id_cat = b.id_cat)
		WHERE redirect = {string:empty_string}',
		array(
			'empty_string' => '',
		)
	);
	
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$board_names[$row['id_board']] = $row['cat_name'] . ' - ' . $row['board_name'];
	$smcFunc['db_free_result']($request);
		
	array_push($boardoptions_1, $board_names);
	array_push($boardoptions_2, $board_names);
	array_push($boardoptions_3, $board_names);
	array_push($boardoptions_4, $board_names);
	array_push($boardoptions_5, $board_names);
	
	// create assoc array of users and keys:
	$key_assoc_array = array();
	
	// Create an array of all the keys we have, if we've got valid userid and api key pairs.
	if (!empty($modSettings['eveevents_keyid_1']) && !empty($modSettings['eveevents_vcode_1'])) 
		$key_assoc_array['1'] = array($modSettings['eveevents_keyid_1'], $modSettings['eveevents_vcode_1']);
	if (!empty($modSettings['eveevents_keyid_2']) && !empty($modSettings['eveevents_vcode_2'])) 
		$key_assoc_array['2'] = array($modSettings['eveevents_keyid_2'], $modSettings['eveevents_vcode_2']);
	if (!empty($modSettings['eveevents_keyid_3']) && !empty($modSettings['eveevents_vcode_3'])) 
		$key_assoc_array['3'] = array($modSettings['eveevents_keyid_3'], $modSettings['eveevents_vcode_3']);
	if (!empty($modSettings['eveevents_keyid_4']) && !empty($modSettings['eveevents_vcode_4'])) 
		$key_assoc_array['4'] = array($modSettings['eveevents_keyid_4'], $modSettings['eveevents_vcode_4']);
	if (!empty($modSettings['eveevents_keyid_5']) && !empty($modSettings['eveevents_vcode_5'])) 
		$key_assoc_array['5'] = array($modSettings['eveevents_keyid_5'], $modSettings['eveevents_vcode_5']);

	// Do we have a userid and API Key?
	if (!empty($key_assoc_array)) {
		
		$evesettingsmessage = $txt['eveevents_characterIDs'] . "<br />\n";
		foreach ($key_assoc_array as $keyarray) {
			// yes!  Therefore we can go and grab some userids.
			$characters = EveEventGetAvailableCharacters($keyarray[0], $keyarray[1]);
			
			if (empty($characters)) {
				$evesettingsmessage .= $txt['eve_events_missing_characters'] . $keyarray[0] . "<br />";
			} else {
				foreach ($characters as $character_id => $character_name) {
					$value = $character_name . " (" . $character_id . ")<br />";
					$evesettingsmessage .= $value;
				}
			}		
		}
		
	} else {
		// no valid userid/apikey pairs
		$evesettingsmessage = $txt['eveevents_noapidetailsmsg'];		
	}
	
	$context['settings_message'] = $evesettingsmessage;
	$config_vars = array(
		array('check', 'eveevents_disable_ccp', 'help' => 'eveevents_disable_ccp_help'),
		array('check', 'eveevents_single_ccp', 'help' => 'eveevents_single_ccp_help'),
		array('check', 'eveevents_attendance_posting', 'help' => 'eveevents_attendance_posting_help'),
		'',
		array('text', 'eveevents_keyid_1',),
		array('text', 'eveevents_vcode_1', 'size' => 100),
		array('text', 'eveevents_character_id_1'),
		$boardoptions_1,
		array('text', 'eveevents_emailaddress_1', 'size' => 50),
		'',
		$txt['eveevents_nextchar'],
		array('text', 'eveevents_keyid_2'),
		array('text', 'eveevents_vcode_2', 'size' => 100),
		array('text', 'eveevents_character_id_2'),
		$boardoptions_2,
		array('text', 'eveevents_emailaddress_2', 'size' => 50),
		'',
		$txt['eveevents_nextchar'],
		array('text', 'eveevents_keyid_3'),
		array('text', 'eveevents_vcode_3', 'size' => 100),
		array('text', 'eveevents_character_id_3'),
		$boardoptions_3,
		array('text', 'eveevents_emailaddress_3', 'size' => 50),
		'',
		$txt['eveevents_nextchar'],
		array('text', 'eveevents_keyid_4'),
		array('text', 'eveevents_vcode_4', 'size' => 100),
		array('text', 'eveevents_character_id_4'),
		$boardoptions_4,
		array('text', 'eveevents_emailaddress_4', 'size' => 50),
		'',
		$txt['eveevents_nextchar'],
		array('text', 'eveevents_keyid_5'),
		array('text', 'eveevents_vcode_5', 'size' => 100),
		array('text', 'eveevents_character_id_5'),
		$boardoptions_5,
		array('text', 'eveevents_emailaddress_5', 'size' => 50),
	);
	if ($return_config)
		return $config_vars;

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=eveevents';	
	$context['settings_title'] = $txt['eveevents_adminsettingsheader'];

	if (empty($config_vars)) {
		$context['settings_save_dont_show'] = true;
		$context['settings_message'] = '<div style="text-align: center">' . $txt['modification_no_misc_settings'] . '</div>';

		 return prepareDBSettingContext($config_vars);
	}

	if (isset($_GET['save'])) {
		checkSession();

		$save_vars = $config_vars;

		saveDBSettings($save_vars);

		redirectexit('action=admin;area=modsettings;sa=eveevents');
	}
    prepareDBSettingContext($config_vars);

}
?>